var globalTranslate = {
	'mod_cti_Connected': 'Модуль работает корректно',
	'mod_cti_Disconnected': 'Отключен',
	'mod_cti_ConnectionProgress': 'Запускаются сервисы модуля',
	'mod_cti_ConnectionError': 'Ошибка работы модуля',
	'mod_cti_ConnectionTo1CError': 'Нет связи с базой 1С',
	'mod_cti_UpdateStatus': 'Обновление статуса',
	'mod_cti_trying': ' Попытка соединения №',
	'mod_cti_LicenseProblem': 'Проблема с лицензией',
};

const ModuleCTIClient = {

	settingsForm: document.editSettings,
	initialize() {
		// Отправка формы для сохранения настроек
		$('form').on('submit', function (e) {
			e.preventDefault();
			ModuleCTIClient.saveSettings();
		});

		// Подписка на изменнеие режима веб сервиса
		$('input:radio[name="web_service_mode"]').change(function () {
			ModuleCTIClient.onWebServiceRadioChange();
		});
		ModuleCTIClient.onWebServiceRadioChange();

		// Подписка на изменнеие сотояния лицензионного ключа
		$('input:text[name="saaskey"]').change(function () {
			ModuleCTIClient.onSaasKeyChange();
		});
		ModuleCTIClient.onSaasKeyChange();
		moduleCTIClientConnectionCheckWorker.initialize();
	},
	/**
	 * При выборе режима работы модуля
	 */
	onWebServiceRadioChange() {
		//Скроем параметры настройки сервера, если выбран режим LongPool
		if (ModuleCTIClient.settingsForm.web_service_mode.value === "1") {
			$('#only-webservice-mode').removeAttr('disabled');
		} else {
			$('#only-webservice-mode').attr('disabled', 'disabled')
		}
	},
	/**
	 *  При изменении поля лицензионный ключ
	 */
	onSaasKeyChange() {
		// Спрячем секцию регистрации, если заполнен лицензионный ключ
		if (isEmpty(ModuleCTIClient.settingsForm.saaskey.value)) {
			$('#couponSection').addClass('invisible');
			$('#getTrialLicenseSection').removeClass('invisible');
		} else {
			$('#couponSection').removeClass('invisible');
			$('#getTrialLicenseSection').addClass('invisible');
		}
	},
	/**
	 * Валидация формы перез сохранением настроек
	 * @returns {boolean}
	 */
	validateForm() {
		if (typeof ModuleCTIClient.settingsForm !== 'undefined') {
			ModuleCTIClient.settingsForm.server1chost.focus();
		}

		if (ModuleCTIClient.settingsForm.web_service_mode.value === "1") {
			if (isEmpty(ModuleCTIClient.settingsForm.server1chost.value))
				return warnInvalid(ModuleCTIClient.settingsForm.server1chost, "Не заполнен адрес сервера 1С");

			if (!isInteger(ModuleCTIClient.settingsForm.server1cport.value))
				return warnInvalid(ModuleCTIClient.settingsForm.server1cport, "Не заполнен порт для связи с 1С");

			if (isEmpty(ModuleCTIClient.settingsForm.database.value))
				return warnInvalid(ModuleCTIClient.settingsForm.database, "Не заполнен параметр точки публикации вебсервиса 1С");

			if (isEmpty(ModuleCTIClient.settingsForm.login.value))
				return warnInvalid(ModuleCTIClient.settingsForm.login, "Не заполнен логин от вебвервиса 1С");

			if (isEmpty(ModuleCTIClient.settingsForm.password.value))
				return warnInvalid(ModuleCTIClient.settingsForm.secret, "Не заполнен пароль от вебвервиса 1С");
		}

		// Проверим регистрационнцю форму
		if (isEmpty(ModuleCTIClient.settingsForm.saaskey.value)) {
			if (isEmpty(ModuleCTIClient.settingsForm.companyname.value))
				return warnInvalid(ModuleCTIClient.settingsForm.companyname, "Не заполнено название компании для получения лицензии");

			if (isEmpty(ModuleCTIClient.settingsForm.contact.value))
				return warnInvalid(ModuleCTIClient.settingsForm.contact, "Не заполнен контакт для получения лицензии");

			if (isEmpty(ModuleCTIClient.settingsForm.email.value) || ModuleCTIClient.validateEmail(ModuleCTIClient.settingsForm.email.value) === false)
				return warnInvalid(ModuleCTIClient.settingsForm.email, "Не корректно заполнен email контактного лица для получения лицензии");

			if (isEmpty(ModuleCTIClient.settingsForm.telefone.value))
				return warnInvalid(ModuleCTIClient.settingsForm.telefone, "Не заполнен телефон контактного лица для получения лицензии");

		}

		return true;
	},

	/**
	 * Validate Email address
	 * @returns {boolean}
	 */
	validateEmail(email) {
	var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
	return re.test(String(email).toLowerCase());
	},

	/**
	 * Сохранение настроек из формы
	 * @returns {boolean}
	 */
	saveSettings() {
		if (ModuleCTIClient.validateForm() === false) {
			return false;
		}
		$('#submit').blur();
		$('#submit').prop("disabled", true);
		$('#submit').text("Сохраняем...");
		var frmdata = $('form').serialize();
		$.post('ajax.php?module=pt1coutpanel&command=edit', frmdata)
			.done(function (data) {
				if (data.status) {
					fpbxToast('Настройки сохранены', '', 'success');
					if (data.need_reload === true) {
						location.reload();
					}
				} else {
					notie.alert(4, data.messages, 30);
				}
				moduleCTIClientConnectionCheckWorker.initialize();
			})
			.fail(function (jqXHR, status, error) {
				if (typeof jqXHR.responseJSON !== 'undefined') {
					fpbxToast('Error: ' + jqXHR.responseJSON.error.message);
				} else {
					fpbxToast('Unknown Error');
				}
			})
			.always(function () {
				$('#submit').prop("disabled", false);
			});
		return true;
	}
};

$(document).ready(function () {

	ModuleCTIClient.initialize();
});

/**
 * Тестирование соединения модуля с 1С
 */
var moduleCTIClientConnectionCheckWorker = {
	$formObj: $('#module-cti-client-form'),
	$moduleStatus: $('#module-cti-status'),
	timeOut: 3000,
	timeOutHandle: '',
	errorCounts: 0,
	initialize: function () {
		function initialize() {
			if (isEmpty(ModuleCTIClient.settingsForm.saaskey.value)){
				moduleCTIClientConnectionCheckWorker.changeStatus('LicenseProblem');
			} else {
				$('.message.ajax').remove();
				moduleCTIClientConnectionCheckWorker.errorCounts = 0;
				moduleCTIClientConnectionCheckWorker.restartWorker();
			}

		}

		return initialize;
	}(),
	restartWorker: function () {
		function restartWorker() {
			moduleCTIClientConnectionCheckWorker.changeStatus('Updating');
			window.clearTimeout(moduleCTIClientConnectionCheckWorker.timeoutHandle);
			moduleCTIClientConnectionCheckWorker.worker();
		}

		return restartWorker;
	}(),
	worker: function () {
		function worker() {
			var frmdata = $('form').serialize();
			if ($('#button_reload').is(":visible")) {
				moduleCTIClientConnectionCheckWorker.errorCounts = 0;
			}
			$.post('ajax.php?module=pt1coutpanel&command=check', frmdata)
				.done(function (response) {
					$('.message.ajax').remove();
					if (response.result) {
						moduleCTIClientConnectionCheckWorker.changeStatus('Connected');
						moduleCTIClientConnectionCheckWorker.errorCounts = 0;
					} else {
						moduleCTIClientConnectionCheckWorker.errorCounts += 1;
						if (typeof response.statuses !== 'undefined') {
							$.each(response.statuses, function (key, value) {
								if (typeof value.name !== 'undefined' && value.name === 'crm-1c' && value.state !== 'ok') {
									moduleCTIClientConnectionCheckWorker.changeStatus('ConnectionTo1CError');
								} else if (typeof value.state !== 'undefined'
									&& value.state !== 'ok') {
									if (moduleCTIClientConnectionCheckWorker.errorCounts < 5 ){
										moduleCTIClientConnectionCheckWorker.changeStatus('ConnectionProgress');
									} else {
										moduleCTIClientConnectionCheckWorker.changeStatus('ConnectionError');
									}
								}
							});
						} else {
							// Unknown
							moduleCTIClientConnectionCheckWorker.changeStatus('ConnectionError');
						}
					}
					if (ModuleCTIClient.settingsForm.debug_mode.checked && $('#button_reload').is(":hidden")) {
							var visualErrorString = JSON.stringify(response.statuses, null, 2);
							if (typeof visualErrorString === 'string') {
								visualErrorString = visualErrorString.replace(/\n/g, '<br/>');
								if (response.result){
									$('#debug_mode-help').after("<div class=\"alert alert-success message ajax\">\n\t\t\t\t\t\t\t\t\t<pre style='white-space: pre-wrap'>".concat(visualErrorString, "</pre>\t\t\t\t\t\t\t\t\t\t  \n\t\t\t\t\t\t\t\t</div>"));
								} else {
									$('#debug_mode-help').after("<div class=\"alert alert-danger message ajax\">\n\t\t\t\t\t\t\t\t\t<i class=\"fa fa-spinner fa-spin\"></i>".concat(globalTranslate.mod_cti_trying, "\n\t\t\t\t\t\t\t\t\t").concat(moduleCTIClientConnectionCheckWorker.errorCounts, " ...\t\t\t\t\t\t\n\t\t\t\t\t\t\t\t\t<pre style='white-space: pre-wrap '>").concat(visualErrorString, "</pre>\t\t\t\t\t\t\t\t\t\t  \n\t\t\t\t\t\t\t\t</div>"));
								}
							}
					}
					moduleCTIClientConnectionCheckWorker.timeoutHandle = window.setTimeout(moduleCTIClientConnectionCheckWorker.worker, moduleCTIClientConnectionCheckWorker.timeOut);
				})
				.fail(function (jqXHR, status, error) {
					if (typeof jqXHR.responseJSON !== undefined) {
						fpbxToast('Error: ' + jqXHR.responseJSON.error.message);
					} else {
						fpbxToast('Unknown Error');
					}
				});

		}

		return worker;
	}(),

	/**
	 * Обновление статуса модуля
	 * @param status
	 */
	changeStatus: function () {
		function changeStatus(status) {
			moduleCTIClientConnectionCheckWorker.$moduleStatus.removeClass('label-default').removeClass('label-warning').removeClass('label-success').removeClass('label-danger');

			switch (status) {
				case 'Connected':
					moduleCTIClientConnectionCheckWorker.$moduleStatus.addClass('label-success').html(globalTranslate.mod_cti_Connected);
					break;

				case 'Disconnected':
					moduleCTIClientConnectionCheckWorker.$moduleStatus.addClass('label-default').html(globalTranslate.mod_cti_Disconnected);
					break;

				case 'ConnectionProgress':
					moduleCTIClientConnectionCheckWorker.$moduleStatus.addClass('label-warning').html("<i class=\"fa fa-spinner fa-spin\"></i>".concat(globalTranslate.mod_cti_ConnectionProgress));
					break;

				case 'ConnectionTo1CError':
					moduleCTIClientConnectionCheckWorker.$moduleStatus.addClass('label-warning').html("<i class=\"fa fa-spinner fa-spin\"></i>".concat(globalTranslate.mod_cti_trying, " ").concat(moduleCTIClientConnectionCheckWorker.errorCounts, "... ").concat(globalTranslate.mod_cti_ConnectionTo1CError));
					break;

				case 'ConnectionError':
					moduleCTIClientConnectionCheckWorker.$moduleStatus.addClass('label-danger').html("<i class=\"fa fa-spinner fa-spin\"></i>".concat(globalTranslate.mod_cti_trying, " ").concat(moduleCTIClientConnectionCheckWorker.errorCounts, "... ").concat(globalTranslate.mod_cti_ConnectionError));
					break;

				case 'Updating':
					moduleCTIClientConnectionCheckWorker.$moduleStatus.addClass('label-default').html("<i class=\"fa fa-spinner fa-spin\"></i>".concat(globalTranslate.mod_cti_UpdateStatus));
					break;

				case 'LicenseProblem':
					moduleCTIClientConnectionCheckWorker.$moduleStatus.addClass('label-default').html(globalTranslate.mod_cti_LicenseProblem);
					break;
				default:
					moduleCTIClientConnectionCheckWorker.$moduleStatus.addClass('label-danger').html(globalTranslate.mod_cti_ConnectionError);
					break;
			}
		}

		return changeStatus;
	}()
};
